;***************************************************************************
;
; File Name		:'Main.asm"
; Title			:PS/2 Keyboard Simulator
; Date			:2006.12.13.
; Version		:1.0.0
; Support telephone	:+36-70-333-4034, +36-30-9541-658
; Support fax		:
; Support Email		:info@vfx.hu
; Target MCU		:ATtiny13
;
;***************************************************************************
;	D E S C R I P T I O N
;
;
;  CKSEL = 10
;  SUT   = 10
;  CKDIV = 1
;
;
;* R15 regisztert modositani tilos!
;* Atjaro az interrupt rutinok es a foprogram kozott!!!!
;				; 0. = 1 ismetles kell a bill.nyomas utan, Timer lejart
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  	why
;	----	----------  ---		------------------------------------
;	0.01	2006.12.13  VFX		Creation based on 8515
;
;
;***************************************************************************
;
.include "tn13def.inc"


;***************************************************************************
;* Const Def

.equ	TRUE	=0xFF		;Yes
.equ	FALSE	=0x00		;No

.equ	MAJOR_REV	='1'
.equ	MINOR_REV	='0'
.equ	MINOR_REVB	='0'

;System

				;Oscillator: f=internal, 9.6 MHz
.equ	CLKDIV = 0		;CLKPS = 3 - div 8
.equ	SYSCLK = 9600000	;System Clock [Hz]

.equ	SYSTACK = 1000		;1000Hz system interrupt

.equ	RAMSTRT = 0x60

;**************************************************************************
;* Hardware Def.
;
;.include "hw.inc"

;***************************************************************************
;**** VARIABLES
.DSEG
.org	RAMSTRT

Flag1:	 .BYTE 1		;Flagbitek
				;2   = paros/paratlan szamlalo led villogtatashoz
				;1:0 = scan mode 01 = scan1, 10 =  scan2, 11 = scan3

KeyHead: .BYTE 1		;Bill. puffer eleje
KeyTrail:.BYTE 1		;Bill. puffer vege


PS2Flag: .BYTE 1		;PS2 flag csak az int. rutin hasznalhatja
				;3. = 1 Parameterre var, komunikacio kozben vagyunk
				;2. = 1 Request resend
				;1. = 1 Resend last data to host
				;0. = 1 Send ACK
				
PS2NextA:.BYTE 2		;PS2 program cim, ahova a kovetkezo int ugrik
LastSend:.BYTE 1		;PS2 Utoljara kuldott kod
RepChar: .BYTE 1		;karakter sorszama amit ismetelni kell

ParamErr:.BYTE 1		;parameterre max 4ms ideig var utana hiba


.EQU	KeyBuffLen = 6
KeyBuff:  .BYTE KeyBuffLen		;Transmit key-buffer


;***************************************************************************
.ESEG
dumyspace:	.dd 4		;compatibility with 8515 errata


;***************************************************************************
;****		I N T E R R U P T S
;****
;***************************************************************************
.CSEG

	rjmp	RESET			; Reset Handler
	rjmp	EXT_INT0		; IRQ0 Handler
	rjmp	PC_INT0			; Pin change Req0 Handler
	rjmp	TIM0_OVF		; Timer0 Overflow Handler
	rjmp	EE_RDY			; EEPROM Ready Handler
	rjmp	ANA_COMP		; Analog Comparator Handler
	rjmp	TIM0_COMPA		; Timer0 CompareA Handler
	rjmp	TIM0_COMPB		; Timer0 CompareB Handler
	rjmp	WDT			; Watchdog Time-out Handler
	rjmp	AADC			; ADC Conversion Complete Handler


.include	"isr.asm"
//.include	"Timer0_t13.asm"


;************************************************************************
;************************************************************************
;* RESET

RESET:		cli				;GLOBAL INTERRUP DIS.

		ldi	R16, low(RAMEND)
		out	SPL,R16

		clr	R15		;Flags!!!
		ldi	YL,LOW(RAMSTRT)
		ldi	YH,HIGH(RAMSTRT) ;BAZIS 'Y' +0

		std	Y+KeyHead-RAMSTRT,R15
		std	Y+KeyTrail-RAMSTRT,R15

		ldi	R16,0b001000000		;Sleep Enabled, Idle
		out	MCUCR,R16		;

		rcall	Init_PS2


		ldi	R16,2			;alapbol a 2. tipusu scan kod kell
		STD	Y+Flag1-RAMSTRT,R16 

		sei

;***********************************************************************
;***********************************************************************
;********     M     A      I      N				********
;********							********
;***********************************************************************
Main: 
		rcall	Delay45us
		rcall	Delay45us
		rcall	Delay45us
		rcall	Delay45us
		rcall	Delay45us
		rcall	Delay45us
		nop
		rcall	PS2_Com

		rjmp	Main

;**********************************************************************
;* Iclude files 

.include	"ps2.asm"


;***************************************************************************
;**** VARIABLES
.DSEG
SWstack:	.byte 45	;45 byte azert kellhet stacknek
MaxUsedRAM:	.BYTE 1		;utolso byte jelzo, csak azert hogy ne lepjuk tul az RAMEND byte-ot
